; Turbo Assembler program MOVING STARS v1.10
; by SeaD

Ideal
P286
Model	TINY
Assume	cs:CODE, ds:DATA

Include 'service.inc'
Include 'curves2.mac'
Include 'random.mac'

Stars_Num	   EQU 000A0h

Stack	00100h

Segment DATA
  Sinus1x1diff
  Sinus2x1diff
  Sinus3x1diff
  Sinus4x1diff
  Random8bit
  Stars       DB Stars_Num DUP(000h,000h,?,?)
  x_Diff      DW ?
  y_Diff      DW ?
EndS

Segment CODE
  Start:
	push  DATA
	pop   ds
	GraphVmode
	mov   ax,00C00h
	int   Dos_Int
	call  Init_Stars
	call  Set_Palette
	call  New_Curve
	mov   [x_Diff],bx
	call  New_Curve
	add   bx,00180h
	mov   [y_Diff],bx
	push  Screen_Buffer_SEG
	pop   es
	mov   ax,00004h
	xor   cx,cx
	xor   dx,dx
	int   Mouse_Int
	call  Clear_Screen

  LopStars:
	call  Get_Stars
	call  Calc_Coords
	call  Put_Stars

	mov   cx,00010h
	call  Wait_Retrace

	mov   ax,00003h
	int   Mouse_Int
	and   bx,00007h
	jnz   S ExitStars
	and   cx,cx
	jnz   S ExitStars
	and   dx,dx
	jnz   S ExitStars
	mov   ah,006h
	mov   dl,0FFh
	int   Dos_Int
	jz    LopStars
  ExitStars:
	DosVmode
	ExitToDos

Proc	Get_Stars
	mov   si,OFF Stars
	mov   cx,Stars_Num
  LopGet:
	xor   ah,ah
	mov   al,[si+2]
	shl   ax,6
	mov   di,ax
	shl   ax,2
	add   di,ax
	add   di,[si]
	mov   al,000h
	mov   [es:di],al
	add   si,00004h
	loop  LopGet
	ret
EndP

Proc	Put_Stars
	mov   si,OFF Stars
	mov   cx,Stars_Num
  LopPut:
	xor   ah,ah
	mov   al,[si+2]
	shl   ax,6
	mov   di,ax
	shl   ax,2
	add   di,ax
	add   di,[si]
	mov   al,[si+3]
	or    al,080h
	mov   [es:di],al
	add   si,00004h
	loop  LopPut
	ret
EndP

Proc	Calc_Coords
	mov   si,OFF Stars
	mov   bx,[x_Diff]
	mov   dx,[y_Diff]
	mov   cx,Stars_Num
  LopCalc:
	mov   ah,[si+3]
	mov   al,ah
	mov   di,ax

	mov   al,[di+bx]
	xor   ah,ah
	cmp   al,040h
	jb    LblCalc1
	xor   al,080h
	jz    LblCalc1
	not   ah
  LblCalc1:
	xor   al,ah
	add   ax,[si]
	cmp   ax,Screen_Width+00020h
	jb    LblCalc2
	and   ax,Screen_Width-00001h
  LblCalc2:
	cmp   ax,Screen_Width
	jb    LblCalc3
	and   ax,00007h
  LblCalc3:
	mov   [si],ax
	inc   si
	inc   si

	xchg  bx,dx
	mov   al,[di+bx]
	xchg  dx,bx
	xor   ah,ah
	cmp   al,040h
	jb    LblCalc4
	xor   al,080h
	jz    LblCalc4
	not   ah
  LblCalc4:
	xor   al,ah
	add   al,[si]
	cmp   al,Screen_Height+020h
	jb    LblCalc5
	and   al,Screen_Height-001h
  LblCalc5:
	cmp   al,Screen_Height
	jb    LblCalc6
	and   al,007h
  LblCalc6:
	mov   [si],al
	inc   si
	inc   si
	loop  LopCalc

	inc   bx
	mov   al,[bx]
	inc   al
	jnz   LblCalc7
	call  New_Curve
  LblCalc7:
	mov   [x_Diff],bx
	mov   bx,dx
	inc   bx
	mov   al,[bx+1]
	inc   al
	jnz   LblCalc8
	call  New_Curve
  LblCalc8:
	mov   [y_Diff],bx
	ret
EndP

Proc	New_Curve
	push  es
	xor   ax,ax
	mov   es,ax
	mov   al,[es:OFF Timer_OFF]
	pop   es
	mov   bx,OFF Sin4ax1diff
	and   al,003h
	jz    ExitNew
	mov   bx,OFF Sin2ax1diff
	dec   al
	jz    ExitNew
	mov   bx,OFF Sin3ax1diff
	dec   al
	jz    ExitNew
	mov   bx,OFF Sin4ax1diff
  ExitNew:
	ret
EndP

Proc	Init_Stars
	xor   ax,ax
	mov   es,ax
	mov   si,OFF Random
	mov   di,OFF Stars
	mov   bx,ax
	mov   dx,ax
	mov   cx,Stars_Num
  LopInit:
	mov   [di],dx
	inc   dx
	inc   dx
	inc   di
	inc   di
	mov   al,[si+bx]
	xor   al,[es:OFF Timer_OFF]
	cmp   al,Screen_Height
	jb    LblInit
	sub   al,038h
  LblInit:
	mov   [di],al
	inc   di
	mov   [di],ah
	inc   di
	inc   ah
	inc   ah
	and   ah,007h
	add   bl,015h
	and   bl,03Fh
	push  dx
	push  cx
	mov   cx,00002h
	call  Wait_Retrace
	pop   cx
	pop   dx
	loop  LopInit
	ret
EndP

Proc	Clear_Screen
	xor   ax,ax
	mov   di,ax
	mov   cx,Screen_Size/00002h
	cld
	rep   stosw
	ret
EndP

Proc	Set_Palette
	mov   dx,Pal_Register_Mask
	mov   al,087h
	out   dx,al
	mov   dx,Pal_Register_WR
	xor   al,al
	out   dx,al
	mov   dx,Pal_Data
	out   dx,al
	out   dx,al
	out   dx,al
	mov   bl,017h
	mov   ah,080h
	mov   cx,00004h
  LopPalette:
	mov   dx,Pal_Register_WR
	mov   al,ah
	out   dx,al
	mov   dx,Pal_Data
	mov   al,bl
	out   dx,al
	add   al,008h
	out   dx,al
	out   dx,al
	add   bl,008h
	inc   ah
	inc   ah
	loop  LopPalette
	ret
EndP

Proc	Wait_Retrace
LopRetr:
	WaitRetrace
	loop  LopRetr
	ret
EndP

EndS

End	Start
