// Borland C program The SPACE
// SeaD 1998

#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include "service.h"

#define STARS_NUM 2000
#define X_VIEW    2000
#define Y_VIEW    1000
#define Z_VIEW    20
#define PUT_STAR  0xFF
#define GET_STAR  0x00

typedef struct matrix_struct {
  float e[4][4];
  } matrix_typ, *matrix_ptr;

typedef struct star_struct {
  float x, y, z;
  int x_int, y_int;
  } star_typ, *star_ptr;

typedef struct space_struct {
  star_typ star[STARS_NUM];
  int mask;
  float x_vel, y_vel, z_vel;
  float x_scl, y_scl, z_scl;
  float x_ang, y_ang, z_ang;
//  void *x_fnc(space_ptr), *y_fnc(space_ptr), *z_fnc(space_ptr);
  } space_typ, *space_ptr;

float x_vel_fnc, y_vel_fnc, z_vel_fnc;
float x_scl_fnc, y_scl_fnc, z_scl_fnc;
float x_ang_fnc, y_ang_fnc, z_ang_fnc;

void Set_Vmode(BYTE mode) {
  union REGS r;
  r.h.ah = 0;
  r.h.al = mode;
  int86(VGA_INT, &r, &r);
  }

void Set_Palette(void) {
  int n, r;
  outp(PAL_REGISTER_MASK, 0xFF);
  for (n = 63, r = 20; n >= 0; n -= 3) {
    outp(PAL_REGISTER_WR, r--);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    }
  }

void Wait_Retrace(void) {
  while (inp(VGA_INPUT1) & RETRACE_BIT);
  while (!(inp(VGA_INPUT1) & RETRACE_BIT));
  }

void Put_Stars(space_ptr s) {
  BYTE far *video_buf = (BYTE far *)0xA0000000l;
  int n, color;
  for (n = 0; n < STARS_NUM; n++) {
    color = (20 - (int)s->star[n].z) & s->mask;
    if (s->star[n].x_int && s->star[n].y_int)
      video_buf[(s->star[n].y_int << 8) + (s->star[n].y_int << 6) + s->star[n].x_int] = color;
    }
  }

void Create_Space(space_ptr s) {
  int n;
  for (n = 0; n < STARS_NUM; n++) {
    s->star[n].x = random(X_VIEW * 2) - X_VIEW;
    s->star[n].y = random(Y_VIEW * 2) - Y_VIEW;
    s->star[n].z = random(Z_VIEW * 2) - Z_VIEW;
    }
  s->x_vel = 0; s->y_vel = 0; s->z_vel = 0;
  s->x_scl = 1; s->y_scl = 1; s->z_scl = 1;
  s->x_ang = 0; s->y_ang = 0; s->z_ang = 0;
  x_vel_fnc = y_vel_fnc = z_vel_fnc = 0;
  x_scl_fnc = y_scl_fnc = z_scl_fnc = 0;
  x_ang_fnc = y_ang_fnc = z_ang_fnc = 0;
  }
/*
void Matrix_Init(matrix_ptr m) {
  m->e[0][0] = m->e[1][1] = m->e[2][2] = m->e[3][3] = 1;
  m->e[0][1] = m->e[0][2] = m->e[0][3] = 0;
  m->e[1][0] = m->e[1][2] = m->e[1][3] = 0;
  m->e[2][0] = m->e[2][1] = m->e[2][3] = 0;
  m->e[3][0] = m->e[3][1] = m->e[3][2] = 0;
  }

void Matrix_Mul(space_ptr s, matrix_ptr m) {
  float x, y, z;
  x = star->x * m->e[0][0] + star->y * m->e[1][0] + star->z * m->e[2][0] + star->n * m->e[3][0];
  y = star->x * m->e[0][1] + star->y * m->e[1][1] + star->z * m->e[2][1] + star->n * m->e[3][1];
  z = star->x * m->e[0][2] + star->y * m->e[1][2] + star->z * m->e[2][2] + star->n * m->e[3][2];
  star->x = x;
  star->y = y;
  star->z = z;
  }

void Rotate_X(space_ptr s) {
  matrix_typ m;
  int n;
  float cs, sn;
  cs = cos(angle);
  sn = sin(angle);
  m.e[1][1] = cs;
  m.e[1][2] = sn;
  m.e[2][1] = -sn;
  m.e[2][2] = cs;
  for (n = 0; n < obj->vertices_num; n++)
    Mat_Mul((vertex_ptr)&obj->vertices[n], (matrix_ptr)&obj->rotation);
  }

void Rotate_Y(space_ptr s) {
  matrix_typ m;
  int n;
  float cs, sn;
  cs = cos(angle);
  sn = sin(angle);
  m.e[0][0] = cs;
  m.e[0][2] = -sn;
  m.e[2][0] = sn;
  m.e[2][2] = cs;
  for (n = 0; n < obj->vertices_num; n++)
    Mat_Mul((vertex_ptr)&obj->vertices[n], (matrix_ptr)&obj->rotation);
  }

void Rotate_Z(space_ptr s) {
  matrix_typ m;
  int n;
  float cs, sn;
  cs = cos(angle);
  sn = sin(angle);
  m.e[0][0] = cs;
  m.e[0][1] = sn;
  m.e[1][0] = -sn;
  m.e[1][1] = cs;
  for (n = 0; n < obj->vertices_num; n++)
    Mat_Mul((vertex_ptr)&obj->vertices[n], (matrix_ptr)&obj->rotation);
  }
*/
float Func1(float f) {
  return(cos(f * 1) * 33);
  }

float Func2(float f) {
  return(cos(f * 2) * 20);
  }

float Func3(float f) {
  return(sin(f * 2) * 22);
  }

void Move_Stars(space_ptr s) {
  int n;
  float x, y, z;
  for(n = 0; n < STARS_NUM; n++) {
    if ((s->star[n].x += s->x_vel) < -X_VIEW || s->star[n].x >= X_VIEW) {
      s->star[n].x = -s->star[n].x;
      s->star[n].y = random(Y_VIEW * 2) - Y_VIEW;
      s->star[n].z = random(Z_VIEW * 2) - Z_VIEW;
      }
    if ((s->star[n].y += s->y_vel) < -Y_VIEW || s->star[n].y >= Y_VIEW) {
      s->star[n].y = -s->star[n].y;
      s->star[n].x = random(X_VIEW * 2) - X_VIEW;
      s->star[n].z = random(Z_VIEW * 2) - Z_VIEW;
      }
    if ((s->star[n].z += s->z_vel) < -Z_VIEW || s->star[n].z >= Z_VIEW) {
      s->star[n].z = -s->star[n].z;
      s->star[n].x = random(X_VIEW * 2) - X_VIEW;
      s->star[n].y = random(Y_VIEW * 2) - Y_VIEW;
      }
    s->x_vel = Func1(x_vel_fnc += 0.00001);
    s->y_vel = Func3(y_vel_fnc += 0.00001);
//    s->z_scl = Func1(z_scl_fnc += 0.00001);
//    x = s->star[n].x * s->x_scl;
//    y = s->star[n].y * s->y_scl;
//    z = s->star[n].z * s->z_scl;

    if (s->star[n].z > 0 &&
       (s->star[n].x_int = s->star[n].x / s->star[n].z + 160) > 0 &&
        s->star[n].x_int < 319 &&
       (s->star[n].y_int = s->star[n].y / s->star[n].z + 100) > 0 &&
        s->star[n].y_int < 199);
    else {
      s->star[n].x_int = s->star[n].y_int = 0;
      }
    }
  }

void main(void) {
  space_typ space;
//  matrix_typ x_axs, y_axs, z_axs;
  int n;
  randomize();
  Set_Vmode(GRAPH_MODE);
  Set_Palette();
  Create_Space(&space);
  space.x_vel = 0;
  space.y_vel = 0;
  space.z_vel = -0.2;
  while(!kbhit()) {
    Move_Stars(&space);
    space.mask = PUT_STAR;
    Put_Stars(&space);
    Wait_Retrace();
    Wait_Retrace();
    space.mask = GET_STAR;
    Put_Stars(&space);
    }
  Set_Vmode(TEXT_MODE);
  }
