// Borland C program SPACE_EFFECT1
// SeaD 1998

#include <stdlib.h>
#include <dos.h>
#include "service.h"

#define STARS_NUM   1000
#define BEGIN_COLOR 16
#define SPEEDS_NUM  4

typedef struct star_struct {
  int x, y, n;
  int x_off, y_off;
  int x_dir0, y_dir0;
	int x_dir, y_dir;
  int color, speed;
	} star_typ, *star_ptr;

void Set_Vmode(BYTE mode) {
  union REGS regs;
  regs.h.ah = 0;
  regs.h.al = mode;
  int86(VGA_INT, &regs, &regs);
  }

void Set_Palette(void) {
  int n, reg = 0;
  outp(PAL_REGISTER_MASK, 0xFF);
  for (n=0; n<64; n++) {
    outp(PAL_REGISTER_WR, reg++);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_REGISTER_WR, reg++);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_REGISTER_WR, reg++);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_REGISTER_WR, reg++);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    outp(PAL_DATA, n);
    }
  }

void Wait_Retrace(void) {
  while (inp(VGA_INPUT1) & RETRACE_BIT);
  while (!(inp(VGA_INPUT1) & RETRACE_BIT));
  }

void Put_Star(star_ptr star, int pix) {
  char far *video_buf = (char far *)0xA0000000l;
  video_buf[(star->y<<8) + (star->y<<6) + star->x] = pix;
  }

void Init_Star(star_ptr star) {
  int x_end, y_end;
  star->x = 158 + random(4); star->y = 98 + random(4);
  switch(random(4)) {
    case 0: {
	  	x_end = random(320); y_end = 0; break;
      }
    case 1: {
			x_end = random(320); y_end = 199; break;
      }
    case 2: {
			x_end = 0; y_end = random(200); break;
      }
    case 3: {
			x_end = 319; y_end = random(200); break;
      }
    }
  star->x_dir = 1; star->x_dir0 = 1;
  star->x_off = x_end - star->x;
  if(star->x_off<0) {
    star->x_off = -star->x_off;
  	star->x_dir = -1;
  	star->x_dir0 = -1;
    }
  star->y_dir = 1; star->y_dir0 = 1;
  star->y_off = y_end - star->y;
  if(star->y_off<0) {
    star->y_off = -star->y_off;
  	star->y_dir = -1;
		star->y_dir0 = -1;
    }
  if(star->x_off>star->y_off) {
    star->y_dir0 = 0;
    }
  else {
    star->n = star->y_off; star->y_off = star->x_off; star->x_off = star->n;
    star->x_dir0 = 0;
    }
  star->n = star->x_off / 2;
  star->color = BEGIN_COLOR;
  star->speed = random(SPEEDS_NUM) + 1;
	}

void Move_Star(star_ptr star) {
  int n;
  if ((star->color += star->speed)>255)
      Init_Star(star);
  for (n=0; n<star->speed; n++) {
    if((star->n += star->y_off)>star->x_off) {
      star->n -= star->x_off;
      star->x += star->x_dir;
      star->y += star->y_dir;
      if(star->x<0 || star->x>319 || star->y<0 || star->y>199)
        Init_Star(star);
      }
    else  {
      star->x += star->x_dir0;
      star->y += star->y_dir0;
      if(star->x<0 || star->x>319 || star->y<0 || star->y>199)
        Init_Star(star);
      }
    }
  }

void main(void) {
  star_typ star[STARS_NUM];
  int n, m;
  Set_Vmode(GRAPH_MODE);
  Set_Palette();
  randomize();
  for (n=0; n<STARS_NUM; n++) Init_Star(&star[n]);
  for (m=0; m<256; m++)
    for (n=0; n<STARS_NUM; n++) Move_Star(&star[n]);
  while (!kbhit()) {
    for (n=0; n<STARS_NUM; n++) {
      Move_Star(&star[n]);
      Put_Star(&star[n], star[n].color);
      }
    Wait_Retrace();
    for (n=0; n<STARS_NUM; n++)
      Put_Star(&star[n], BLACK);
    }
  Set_Vmode(TEXT_MODE);
  }
